// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{Bin, DockRevealerTransitionType};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlDockRevealer")]
    pub struct DockRevealer(Object<ffi::DzlDockRevealer, ffi::DzlDockRevealerClass>) @extends Bin, gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_dock_revealer_get_type(),
    }
}

impl DockRevealer {
    pub const NONE: Option<&'static DockRevealer> = None;

    #[doc(alias = "dzl_dock_revealer_new")]
    pub fn new() -> DockRevealer {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_dock_revealer_new()).unsafe_cast() }
    }
}

impl Default for DockRevealer {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::DockRevealer>> Sealed for T {}
}

pub trait DockRevealerExt: IsA<DockRevealer> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_dock_revealer_animate_to_position")]
    fn animate_to_position(&self, position: i32, transition_duration: u32) {
        unsafe {
            ffi::dzl_dock_revealer_animate_to_position(
                self.as_ref().to_glib_none().0,
                position,
                transition_duration,
            );
        }
    }

    #[doc(alias = "dzl_dock_revealer_get_child_revealed")]
    #[doc(alias = "get_child_revealed")]
    fn is_child_revealed(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_dock_revealer_get_child_revealed(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_revealer_get_position")]
    #[doc(alias = "get_position")]
    fn position(&self) -> i32 {
        unsafe { ffi::dzl_dock_revealer_get_position(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_dock_revealer_get_position_set")]
    #[doc(alias = "get_position_set")]
    fn is_position_set(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_dock_revealer_get_position_set(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_revealer_get_reveal_child")]
    #[doc(alias = "get_reveal_child")]
    fn reveals_child(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_dock_revealer_get_reveal_child(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_revealer_get_transition_duration")]
    #[doc(alias = "get_transition_duration")]
    fn transition_duration(&self) -> u32 {
        unsafe { ffi::dzl_dock_revealer_get_transition_duration(self.as_ref().to_glib_none().0) }
    }

    #[doc(alias = "dzl_dock_revealer_get_transition_type")]
    #[doc(alias = "get_transition_type")]
    fn transition_type(&self) -> DockRevealerTransitionType {
        unsafe {
            from_glib(ffi::dzl_dock_revealer_get_transition_type(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_revealer_is_animating")]
    fn is_animating(&self) -> bool {
        unsafe {
            from_glib(ffi::dzl_dock_revealer_is_animating(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_dock_revealer_set_position")]
    fn set_position(&self, position: i32) {
        unsafe {
            ffi::dzl_dock_revealer_set_position(self.as_ref().to_glib_none().0, position);
        }
    }

    #[doc(alias = "dzl_dock_revealer_set_position_set")]
    fn set_position_set(&self, position_set: bool) {
        unsafe {
            ffi::dzl_dock_revealer_set_position_set(
                self.as_ref().to_glib_none().0,
                position_set.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_dock_revealer_set_reveal_child")]
    fn set_reveal_child(&self, reveal_child: bool) {
        unsafe {
            ffi::dzl_dock_revealer_set_reveal_child(
                self.as_ref().to_glib_none().0,
                reveal_child.into_glib(),
            );
        }
    }

    #[doc(alias = "dzl_dock_revealer_set_transition_duration")]
    fn set_transition_duration(&self, transition_duration: u32) {
        unsafe {
            ffi::dzl_dock_revealer_set_transition_duration(
                self.as_ref().to_glib_none().0,
                transition_duration,
            );
        }
    }

    #[doc(alias = "dzl_dock_revealer_set_transition_type")]
    fn set_transition_type(&self, transition_type: DockRevealerTransitionType) {
        unsafe {
            ffi::dzl_dock_revealer_set_transition_type(
                self.as_ref().to_glib_none().0,
                transition_type.into_glib(),
            );
        }
    }

    #[doc(alias = "child-revealed")]
    fn connect_child_revealed_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_child_revealed_trampoline<
            P: IsA<DockRevealer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockRevealer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockRevealer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::child-revealed\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_child_revealed_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "position")]
    fn connect_position_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_position_trampoline<
            P: IsA<DockRevealer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockRevealer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockRevealer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::position\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_position_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "position-set")]
    fn connect_position_set_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_position_set_trampoline<
            P: IsA<DockRevealer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockRevealer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockRevealer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::position-set\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_position_set_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "reveal-child")]
    fn connect_reveal_child_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_reveal_child_trampoline<
            P: IsA<DockRevealer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockRevealer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockRevealer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::reveal-child\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_reveal_child_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "transition-duration")]
    fn connect_transition_duration_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_transition_duration_trampoline<
            P: IsA<DockRevealer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockRevealer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockRevealer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::transition-duration\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_transition_duration_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "transition-type")]
    fn connect_transition_type_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_transition_type_trampoline<
            P: IsA<DockRevealer>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlDockRevealer,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(DockRevealer::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::transition-type\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_transition_type_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<DockRevealer>> DockRevealerExt for O {}

impl fmt::Display for DockRevealer {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("DockRevealer")
    }
}
